unit DemoForm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, ATShell, Menus;

type
  TATDemoForm = class(TForm)
    ATShell1: TATShell;
    Edit1: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Button1: TButton;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    Edit5: TEdit;
    CheckBoxQuickView: TCheckBox;
    CheckBoxShowInNew: TCheckBox;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Bevel1: TBevel;
    Label3: TLabel;
    Button5: TButton;
    ListBox1: TListBox;
    Header1: THeader;
    RadioGroup1: TRadioGroup;
    Button6: TButton;
    Button7: TButton;
    Button8: TButton;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    Button9: TButton;
    Button10: TButton;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Select1: TMenuItem;
    N1: TMenuItem;
    exit1: TMenuItem;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure ListBox1DrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
    procedure ListBox1MeasureItem(Control: TWinControl; Index: Integer;
      var Height: Integer);
    procedure FormCreate(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure Button10Click(Sender: TObject);
    procedure exit1Click(Sender: TObject);
  private
    { Private declarations }
     procedure UpdateDemo;
     function ExtensionParams:boolean;
  public
    { Public declarations }
  end;

var
  ATDemoForm: TATDemoForm;

implementation
 Uses DCADlg1, AssocSel;
{$R *.DFM}

function TATDemoForm.ExtensionParams:boolean;
begin
   result:=false;
   if Edit2.text ='' then exit;
   if Edit3.text ='' then exit;
   if Edit4.text ='' then exit;
   if Edit5.text ='' then exit;
   result:=true;
end;

procedure TATDemoForm.Button1Click(Sender: TObject);
var
  cleanup:boolean;
begin
  { if not ExtensionParams then exit;}
   with ATShell1 do
     begin
       if Edit1.text<>'' then
         begin
           Extension:=Edit1.text;
           cleanup:=GetAssociation;
           if cleanup then
             begin
                if messageDlg('Are you sure you wish to CHANGE the "'+ReadType+
                          '" association',mtconfirmation,[mbOk,mbCancel],0)<> mrOk then
                    exit;
             end;
              IconPath:=Edit2.text;
              KeyName:=Edit3.text;
              PathToApp:=Edit4.text;
              TypeName:=Edit5.text;
              QuickView:=CheckboxQuickView.checked;
              ShowInNew:=CheckboxShowInNew.checked;
              if RadioGroup1.itemindex=0 then
                ParamPos:=ppBefore
              else
                ParamPos:=ppAfter;
              if cleanup then
                RemoveAssociation(true,false);
              CreateAssociation;
         end;
     end;
end;

procedure TATDemoForm.UpdateDemo;
var
   aList:tstringlist;
  i:integer;
begin
   with ATShell1 do
     begin
               Edit1.text:= Extension;
               Edit2.Text:= IconPath;
               Edit3.Text:= KeyName;
               Edit4.Text:= PathToApp;
               Edit5.Text:= TypeName;
               CheckboxQuickView.checked:=QuickView;
               CheckboxShowInNew.checked:=ShowInNew;
               with Listbox1.items do
                 begin
                   clear;
                   if Shellcommands<>'' then
                     begin
                       alist:=parseShellCommandList(ShellCommands);
                       try
                        for i:=0 to alist.count-1 do
                           begin
                             add(copy(alist[i],1,pos('|',alist[i])-1)+'|'+
                                copy(alist[i], pos('|',alist[i])+1,length(alist[i])));
                            end; {of for}
                       finally
                        alist.free;
                       end;{of try}
                     end;
                 end;
   end;
end;

procedure TATDemoForm.Button2Click(Sender: TObject);
begin
   with ATShell1 do
     begin
       if Edit1.text<>'' then
         begin
           Extension:=Edit1.text;
           if not GetAssociation then
                messageDlg('Their is no association for "'+edit1.text+'" files.',mtinformation,
                         [mbOk],0);
           UpdateDemo;
         end;
     end;
end;

procedure TATDemoForm.Button3Click(Sender: TObject);
var
  AssocStr:string;
begin
   if not ExtensionParams then exit;
   with ATShell1 do
     begin
       if Edit1.text<>'' then
         begin
           Extension:=Edit1.text;
           AssocStr:=AssociationExists;
           if AssocStr<>'' then
             begin
                if messageDlg('Are you sure you wish to CLEAR the "'+ReadType+
                          '" association.',mtconfirmation,[mbOk,mbCancel],0)= idOk then
                RemoveAssociation(false,true);
             end;
         end;
     end;
end;

procedure TATDemoForm.Button4Click(Sender: TObject);
var
  AssocStr:string;
begin
   if not ExtensionParams then exit;
   with ATShell1 do
     begin
       if Edit1.text<>'' then
         begin
           Extension:=Edit1.text;
           AssocStr:=AssociationExists;
           if AssocStr<>'' then
             begin
                if messageDlg('Are you sure you wish to DELETE the "'+ReadType+
                          '" association. The association, shell commands and extensions for all "'+
                          Extension+'" files will be permanently removed.'
                          ,mtconfirmation,[mbOk,mbCancel],0)= idOk then
                RemoveAssociation(true,true);
                
             end;
         end;
     end;
end;

procedure TATDemoForm.Button5Click(Sender: TObject);
var
  EditDlg: TShellCommandsDlg;
  aList:tstringlist;
  i:integer;
begin
  EditDlg := TShellCommandsDlg.Create(Application);
  try
    EditDlg.SetShellCommandList(ATShell1.ShellCommands);
    if EditDlg.ShowModal = mrOk then
      begin
       ATShell1.ShellCommands:=EditDlg.ShellCommandList;
        with Listbox1.items do
          begin
           clear;
           if ATShell1.Shellcommands<>'' then
              begin
                 alist:=parseShellCommandList(ATShell1.ShellCommands);
                try
                  for i:=0 to alist.count-1 do
                    begin
                       add(copy(alist[i],1,pos('|',alist[i])-1)+'|'+
                       copy(alist[i], pos('|',alist[i])+1,length(alist[i])));
                     end; {of for}
                 finally
                   alist.free;
                 end;{of try}
               end;
            end;   
      end;
  finally
    EditDlg.Free;
  end;
end;

procedure TATDemoForm.ListBox1DrawItem(Control: TWinControl;
  Index: Integer; Rect: TRect; State: TOwnerDrawState);
var
  R: TRect;
  ItemStr, Str: String;
begin
  with (Control as TListBox) do
    begin
      if (odGrayed in State) or (odDisabled in State) then
        Canvas.Font.Color := clGrayText;

      ItemStr := Items[Index];

      R := Rect;
      R.Right := R.Left + Header1.SectionWidth[0];
      str:=copy(ItemStr,1,pos('|',ItemStr)-1);
      Canvas.TextRect(R, R.Left + 2, R.Top, str);

      R.Left := R.Right;
      R.Right := R.Left + Header1.SectionWidth[1];
      Str := copy(ItemStr,pos('|',ItemStr)+1,Length(ItemStr));
      Canvas.TextRect(R, R.Left + 4{(R.Right - R.Left) - Canvas.TextWidth(Str)
       -2} , R.Top, Str);

    end;
end;

procedure TATDemoForm.ListBox1MeasureItem(Control: TWinControl;
  Index: Integer; var Height: Integer);
begin
  Height := (Control as TListBox).Canvas.TextHeight('W');
end;

procedure TATDemoForm.FormCreate(Sender: TObject);
begin
 { change this extension to a bogus extension if ".asd" is already associated}
 ATShell1.Extension:='asd';
 Edit1.text :=ATShell1.extension;
 if not ATShell1.GetAssociation then
   begin
     Edit2.text :='c:\windows\notepad.exe';
     Edit3.text :='ATShell Demo';
     Edit4.text :='c:\windows\notepad.exe';
     Edit5.text :='ATShell Demo File';
     CheckboxQuickView.checked:=true;
     CheckboxShowInNew.checked:=true;
     listbox1.items.add('Print|/p');
     Listbox1.items.add('Test| ');
     ATShell1.ShellCommands:='Print|/p,Test| ,';
   end;
end;

procedure TATDemoForm.Button6Click(Sender: TObject);
begin
  AddByTypeForm:=tAddByTypeForm.create(application);
 try
  if AddByTypeForm.showmodal=mrOk then
     begin
       Edit1.text:= AddByTypeForm.selection;
       Button2Click(Sender);
     end;
 finally
   AddByTypeForm.free;
 end;
end;
        

procedure TATDemoForm.Button7Click(Sender: TObject);
begin
  With SaveDialog1 do
    begin
      if execute then
        begin
          ATShell1.SaveToFile(OpenDialog1.filename);
        end;
    end;
end;

procedure TATDemoForm.Button8Click(Sender: TObject);
begin
  With OpenDialog1 do
    begin
      if execute then
        begin
          ATShell1.LoadFromFile(OpenDialog1.filename);
          UpdateDemo;
        end;
    end;
end;



procedure TATDemoForm.Button9Click(Sender: TObject);
begin
  if not ATShell1.BackupAssociation('ASD Backup') then
    showmessage('Could not backup association');;
end;

procedure TATDemoForm.Button10Click(Sender: TObject);
begin
  if not ATShell1.RestoreAssociation('ASD Backup') then
    showmessage('Could not restore association');;
end;


procedure TATDemoForm.exit1Click(Sender: TObject);
begin
  Close;
end;

end.
